package proiect;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class Menu {
	static JFrame frame;
	static JPanel root;
	static JButton bNew;
	static JButton bList;
	static JButton bExit;

	private Form newForm = null;
	private Store store;

	public Menu() {
		store = new Store();
		store.load();

		frame = new JFrame("Proiect PJ");
		root = new JPanel();
		root.setLayout(new FlowLayout());

		Menu that = this;
		bNew = new JButton("Add object");
		bList = new JButton("List objects");
		bExit = new JButton("Quit program");

		bNew.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				that.newForm = new Form(that.onNewSave(), that.onNewCancel());
			}
		});
		bList.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new ListObjects(that.store);
			}
		});
		bExit.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				store.save();
				System.exit(0);
			}
		});

		root.add(bNew);
		root.add(bList);
		root.add(bExit);

		frame.add(root);
		frame.setSize(500, 75);
		frame.setVisible(true);
	}

	private ActionListener onNewSave() {
		return new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				store.add(new Animal(newForm.fSpecies.getText(), newForm.fName.getText(),
						newForm.fIsCarnivore.isSelected()));

				newForm.destroy();
				newForm = null;
			}
		};
	}

	private ActionListener onNewCancel() {
		return new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				newForm.destroy();
				newForm = null;
			}
		};
	}
}
